#include "ADuc7038.h"                           

///////////////////////////////////////////////////////
// Filename:   main.c
// Author:     ADI
// Date:    09/09/2005
// Description:    
///////////////////////////////////////////////////////


// Constants
#define WAKEUP_TIMER_BIT         0x00000010                 
#define GPxDAT_DIR_VAL           0xFF000000

void  InterruptIRQHndlr   (void);

static unsigned long ulDir    = 0x1;
static unsigned long ulLoop   = 0x0;

  
// Function    : MyIRQHandler
// Author      : ADI
// Description : Advance leds based on timer interrupt
// Revision    : 09.09.2005 - Initial
void  InterruptIRQHndlr   (void)
{
   if ((IRQSTA & WAKEUP_TIMER_BIT) != 0)      // Timer2 IRQ?
      {
      if (ulDir)
         {
         GPDAT = GPxDAT_DIR_VAL | (0x00010000 << ulLoop);
         }
      else
         {
         GPDAT = GPxDAT_DIR_VAL | (0x00100000 >> ulLoop);
         }
       ulLoop++;

      if (ulLoop == 0x6)
         {
         ulLoop = 0x0;
         if (ulDir)
            ulDir = 0x0;
         else
            ulDir = 0x1;
         }
      T2CLRI = 0x0; // Clear the interrupt
      }
}

// Function    : ConfigureTimer2
// Description : ConfigureTimer2
// Revision    : 21.06.2005 - Initial
void ConfigureTimer2(void)
{
   // Initialise
   IRQCLR      = WAKEUP_TIMER_BIT;  // Timer2 IRQ
   IRQ         = InterruptIRQHndlr; // Specify Interrupt Service Rountine
   T2LD        = 0x1000;      
   T2CON       = 0x2C0;                                 
   IRQEN       = WAKEUP_TIMER_BIT;    // Timer2 IRQ
}

extern const unsigned char ucConstRandData[];

// Function    : main
// Author      : ADI
// Description : main
// Revision    : 28.07.2008 - Initial
int main(void)
{   
   // Blink Leds on ADuc7038 eval board
   GPCON = 0x0;

   GPDAT = GPxDAT_DIR_VAL;
 

   // Toggle the leds based on timer interrupt
   ConfigureTimer2();

   while (1) ; // loop
}






